
case $? in 0) :;; *) (exit "$?");; esac &&
if (prj_which setuidgid_path setuidgid) 2> /dev/null; then
  :
elif (prj_which setuidgid_path s6-setuidgid) 2> /dev/null; then
  setuidgid() {
    s6-setuidgid ${1+"$@"}
  }
elif (exec perl -e 'use POSIX qw(&setuid &setgid &getpwnam);') \
       > /dev/null 2>&1; then
  setuidgid() {
    perl -le '
use POSIX qw(&setuid &setgid &getpwnam);
my ($acct, @args)=@ARGV;
my @data=getpwnam($acct);
my ($uid, $gid)=@data[2, 3];
setgid($gid) or die("unable to set group id: ", $!, "\n");
$)=$gid." ".$gid;
$) eq $gid." ".$gid or die("unable to set groups\n");
setuid($uid) or die("unable to set user id: ", $!, "\n");
exec({ $args[0] } @args) or die("unable to exec ", $args[0], ": ", $!, "\n");
' ${1+"$@"}
  }
elif (exec python -c 'import pwd') > /dev/null 2>&1; then
  setuidgid() {
    python -c '
import sys, os, pwd
acct=sys.argv[1]
args=sys.argv[2:]
data=pwd.getpwnam(acct)
(uid, gid)=(data.pw_uid, data.pw_gid)
os.setgid(gid)
os.setgroups((gid,))
os.setuid(uid)
os.execvp(args[0], args)
' ${1+"$@"}
  }
elif (exec guile -c "(or (defined? 'setgroups) (exit 1))") \
       > /dev/null 2>&1; then
  setuidgid() {
    guile -c '
(define argv (program-arguments))
(define acct (cadr argv))
(define args (cddr argv))
(define data (getpwnam acct))
(define uid (vector-ref data 2))
(define gid (vector-ref data 3))
(setgid gid)
(setgroups (vector gid))
(setuid uid)
(apply execlp (car args) args)
' ${1+"$@"}
  }
else
  setuidgid() {
    echo "${prj_program-setuidgid}: unable to find a setuidgid program" >&2
    return 100
  }
fi
